local AddOnName, AddOn = ...
local L = LibStub("AceLocale-3.0"):NewLocale(AddOnName, "enUS", true)

L.ADDON_NAME = "Immersive"

-- Bindings
BINDING_HEADER_IMMERSIVE = "Immersive Controls"
BINDING_NAME_IMMERSIVE_PANIC = "Activate Panic Mode"

-- Framework
L.FRAMEWORK_PANIC_MODE_ACTIVATE = "Panic mode has been activated!"
L.FRAMEWORK_PANIC_MODE_DEACTIVATE = "Panic mode has been deactivated!"

-- Api Module
L.API_MODE_ALL_TITLE = "Conditional (All)"
L.API_MODE_ANY_TITLE = "Conditional (Any)"
L.API_MODE_HIDDEN_TITLE = "Always Hidden"

-- Configuration Module
L.CONFIG_CPU_USAGE = "CPU Usage (per second): %.2f%%"
L.CONFIG_RELOAD_REQUIRED = "CVar 'scriptProfile' has been enabled. Reload UI is required."
L.CONFIG_SLIDER_FORMATTED_TEXT = "%s (%ss)"
L.CONFIG_SLIDER_TYPE_DELAY_TEXT = "Delay"
L.CONFIG_SLIDER_TYPE_FADE_TEXT = "Fade"

L.CONFIG_OPTIONS_NAME = "Immersive"
L.CONFIG_OPTIONS_TITLE = "Immersive"
L.CONFIG_OPTIONS_SUBTEXT = "These options affect Immersive and all of its activated modules."
L.CONFIG_OPTIONS_PERFORMANCE_FORMATTED_TEXT = "Performance (%sms)"
L.CONFIG_OPTIONS_PERFORMANCE_TOOLTIP = "Configures the responsiveness of Immersive when performing condition and hotspot checks. Reducing this slider will increase the responsiveness but severely impact the WoW client's performance, increasing this slider can create a delay when fading UI elements but can improve performance on older machines. The recommended settings is 100 milliseconds."
L.CONFIG_OPTIONS_DEBUG_TEXT = "Debug Mode"
L.CONFIG_OPTIONS_DEBUG_TOOLTIP = "Enables developer mode."
L.CONFIG_OPTIONS_PANICSTARTUP_TEXT = "Panic on Startup"
L.CONFIG_OPTIONS_PANICSTARTUP_TOOLTIP = "Activates Panic mode when entering the World of Warcraft."
L.CONFIG_OPTIONS_ACTIONCAM_TITLE = "Action Cam"
L.CONFIG_OPTIONS_ACTIONCAM_TOOLTIP = "Set the mode of the Action Cam feature."
L.CONFIG_OPTIONS_VERSION_TEXT = "|TInterface\\OptionsFrame\\UI-OptionsFrame-NewFeatureIcon:0:0:0:-1|t  Current addon version: v%s"

L.CONFIG_OPTIONS_PROFILES_NAME = "Profiles"
L.CONFIG_OPTIONS_PROFILES_TITLE = "Profiles"
L.CONFIG_OPTIONS_PROFILES_SUBTEXT = "These options affect the currently active settings profile."
L.CONFIG_OPTIONS_PROFILES_RESET_TEXT = "Reset the settings of the currently active profile to its default values"
L.CONFIG_OPTIONS_PROFILES_RESET_TITLE = "Reset Profile"
L.CONFIG_OPTIONS_PROFILES_RESET_TOOLTIP = "All settings in the currently active profile will be reset to their default values."
L.CONFIG_OPTIONS_PROFILES_RESET_PROFILE = "|cffffbb00Current Profile:|cffffffff %s"
L.CONFIG_OPTIONS_PROFILES_COPY_TEXT = "Copy the settings from one existing profile into the currently active profile."
L.CONFIG_OPTIONS_PROFILES_COPY_TITLE = "Existing Profiles"
L.CONFIG_OPTIONS_PROFILES_COPY_TOOLTIP = "The selected existing profile settings will be copied into the currently active profile."

L.CONFIG_OPTIONS_PROFILES_RESET_CONFIRM = "Are you sure you wish to reset the currently active profile to its default values?"
L.CONFIG_OPTIONS_PROFILES_RESET_CONFIRM_YES = "Yes"
L.CONFIG_OPTIONS_PROFILES_RESET_CONFIRM_NO = "No"
L.CONFIG_OPTIONS_PROFILES_COPY_CONFIRM = "Are you sure you wish to override the currently active profile with the selected existing profile?"
L.CONFIG_OPTIONS_PROFILES_COPY_CONFIRM_YES = "Yes"
L.CONFIG_OPTIONS_PROFILES_COPY_CONFIRM_NO = "No"

L.CONFIG_OPTIONS_RELOAD_REQUIRED = "To apply the selected changes, reloading the UI is required. Reload UI now?"
L.CONFIG_OPTIONS_RELOAD_REQUIRED_YES = "Yes"
L.CONFIG_OPTIONS_RELOAD_REQUIRED_NO = "No"

-- Default Module
L.DEFAULT_DEBUG_WELCOME = "Hello |c%s%s|cffffffff, prepare to be immersed!"

L.DEFAULT_BUFF_FRAME_TITLE = "Buffs"
L.DEFAULT_MAIN_MENU_BAR_TITLE = "Main Hotbar"
L.DEFAULT_MICRO_BUTTON_AND_BAGS_BAR_TITLE = "Micro And Bags Bar"
L.DEFAULT_MINIMAP_CLUSTER_TITLE = "Minimap"
L.DEFAULT_MULTIBAR_BOTTOM_LEFT_TITLE = "Hotbar Bottom Left"
L.DEFAULT_MULTIBAR_BOTTOM_RIGHT_TITLE = "Hotbar Bottom Right"
L.DEFAULT_MULTIBAR_LEFT_TITLE = "Side Hotbar Left"
L.DEFAULT_MULTIBAR_RIGHT_TITLE = "Side Hotbar Right"
L.DEFAULT_OBJECTIVE_TRACKER_FRAME_TITLE = "Objective Tracker"
L.DEFAULT_ORDER_HALL_COMMAND_BAR_TITLE = "Order Hall Command Bar"
L.DEFAULT_PARTY_MEMBER_FRAME_TITLE = "Party Members"
L.DEFAULT_PET_ACTION_BAR_FRAME_TITLE = "Pet Action Bar"
L.DEFAULT_PLAYER_FRAME_TITLE = "Player Health Frame"
L.DEFAULT_COMPACT_RAID_FRAME_TITLE = "Raid Members"
L.DEFAULT_STANCE_BAR_FRAME_TITLE = "Stance Bar"
L.DEFAULT_TARGET_FRAME_TITLE = "Target Health Frame"
L.DEFAULT_VEHICLE_LEAVE_BUTTON_TITLE = "Vehicle Leave Button"
L.DEFAULT_VEHICLE_SEAT_INDICATOR_TITLE = "Vehicle Seat Indicator"

L.DEFAULT_AFK_CONDITION_TITLE = "Player Is AFK"
L.DEFAULT_AFK_CONDITION_TOOLTIP = "Check this box to show an element if the player is marked as Away From Keyboard."
L.DEFAULT_ALT_DOWN_CONDITION_TITLE = "Alt Key Is Pressed"
L.DEFAULT_ALT_DOWN_CONDITION_TOOLTIP = "Check this box to show an element if the Alt key is being pressed."
L.DEFAULT_BUFF_ACTIVE_CONDITION_TITLE = "Buff Active"
L.DEFAULT_BUFF_ACTIVE_CONDITION_TOOLTIP = "Check this box to show an element if the player has one or more buffs currently active."
L.DEFAULT_CONTROL_DOWN_CONDITION_TITLE = "Ctrl Key Is Pressed"
L.DEFAULT_CONTROL_DOWN_CONDITION_TOOLTIP = "Check this box to show an element if the Control key is being pressed."
L.DEFAULT_DEBUFF_ACTIVE_CONDITION_TITLE = "Debuff Active"
L.DEFAULT_DEBUFF_ACTIVE_CONDITION_TOOLTIP = "Check this box to show an element if the player has one or more debuffs currently active."
L.DEFAULT_DND_CONDITION_TITLE = "Player Is DND"
L.DEFAULT_DND_CONDITION_TOOLTIP = "Check this box to show an element if the player is marked as Do Not Disturb."
L.DEFAULT_FLYING_CONDITION_TITLE = "Player Is Flying"
L.DEFAULT_FLYING_CONDITION_TOOLTIP = "Check this box to show an element if the player is currently flying."
L.DEFAULT_HUNGRY_CONDITION_TITLE = "Player Not Full Health"
L.DEFAULT_HUNGRY_CONDITION_TOOLTIP = "Check this box to show an element if the player is not at full health."
L.DEFAULT_IN_ARENA_CONDITION_TITLE = "In Arena"
L.DEFAULT_IN_ARENA_CONDITION_TOOLTIP = "Check this box to show an element if the player is currently in an arena."
L.DEFAULT_IN_BATTLEGROUND_CONDITION_TITLE = "In Battleground"
L.DEFAULT_IN_BATTLEGROUND_CONDITION_TOOLTIP = "Check this box to show an element if the player is currently in a battleground."
L.DEFAULT_IN_COMBAT_CONDITION_TITLE = "In Combat"
L.DEFAULT_IN_COMBAT_CONDITION_TOOLTIP = "Check this box to show an element if the player is in combat."
L.DEFAULT_IN_DUNGEON_INSTANCE_CONDITION_TITLE = "In Dungeon Instance"
L.DEFAULT_IN_DUNGEON_INSTANCE_CONDITION_TOOLTIP = "Check this box to show an element if the player is currently in a dungeon instance."
L.DEFAULT_IN_PARTY_CONDITION_TITLE = "In Party"
L.DEFAULT_IN_PARTY_CONDITION_TOOLTIP = "Check this box to show an element if the player is currently in a party."
L.DEFAULT_IN_PET_BATTLE_CONDITION_TITLE = "In Pet Battle"
L.DEFAULT_IN_PET_BATTLE_CONDITION_TOOLTIP = "Check this box to show an element if the player is engaged in a pet battle."
L.DEFAULT_IN_RAID_CONDITION_TITLE = "In Raid"
L.DEFAULT_IN_RAID_CONDITION_TOOLTIP = "Check this box to show an element if the player is currently in a raid group."
L.DEFAULT_IN_RAID_INSTANCE_CONDITION_TITLE = "In Raid Instance"
L.DEFAULT_IN_RAID_INSTANCE_CONDITION_TOOLTIP = "Check this box to show an element if the player is currently in a raid instance."
L.DEFAULT_IN_SCENARIO_CONDITION_TITLE = "In Scenario"
L.DEFAULT_IN_SCENARIO_CONDITION_TOOLTIP = "Check this box to show an element if the player is currently in a scenario."
L.DEFAULT_IN_VEHICLE_CONDITION_TITLE = "In Vehicle"
L.DEFAULT_IN_VEHICLE_CONDITION_TOOLTIP = "Check this box to show an element if the player is currently in a vehicle."
L.DEFAULT_INDOORS_CONDITION_TITLE = "Player Is Indoors"
L.DEFAULT_INDOORS_CONDITION_TOOLTIP = "Check this box to show an element if the player is indoors."
L.DEFAULT_MOVING_CONDITION_TITLE = "Player Is Moving"
L.DEFAULT_MOVING_CONDITION_TOOLTIP = "Check this box to show an element if the player is currently moving."
L.DEFAULT_OUTDOORS_CONDITION_TITLE = "Player Is Outdoors"
L.DEFAULT_OUTDOORS_CONDITION_TOOLTIP = "Check this box to show an element if the player is currently outdoors."
L.DEFAULT_PARTY_HUNGRY_CONDITION_TITLE = "Party Member Not Full Health (Healer Only)"
L.DEFAULT_PARTY_HUNGRY_CONDITION_TOOLTIP = "Check this box to show an element if a party member is not at full health (Healer only)."
L.DEFAULT_RAID_HUNGRY_CONDITION_TITLE = "Raid Member Not Full Health (Healer Only)"
L.DEFAULT_RAID_HUNGRY_CONDITION_TOOLTIP = "Check this box to show an element if a raid member is not at full health (Healer only)."
L.DEFAULT_RESTING_CONDITION_TITLE = "Player Is Resting"
L.DEFAULT_RESTING_CONDITION_TOOLTIP = "Check this box to show an element if the player is an a rest area."
L.DEFAULT_ROLE_DAMAGER_CONDITION_TITLE = "Player Is Dps"
L.DEFAULT_ROLE_DAMAGER_CONDITION_TOOLTIP = "Check this box to show an element if the player's role is Dps."
L.DEFAULT_ROLE_HEALER_CONDITION_TITLE = "Player Is Healer"
L.DEFAULT_ROLE_HEALER_CONDITION_TOOLTIP = "Check this box to show an element if the player's role is Healer."
L.DEFAULT_ROLE_TANK_CONDITION_TITLE = "Player Is Tank"
L.DEFAULT_ROLE_TANK_CONDITION_TOOLTIP = "Check this box to show an element if the player's role is Tank."
L.DEFAULT_SHIFT_DOWN_CONDITION_TITLE = "Shift Key Is Pressed"
L.DEFAULT_SHIFT_DOWN_CONDITION_TOOLTIP = "Check this box to show an element if the Shift key is being pressed."
L.DEFAULT_STATIONARY_CONDITION_TITLE = "Player Is Stationary"
L.DEFAULT_STATIONARY_CONDITION_TOOLTIP = "Check this box to show an element if the player is stationary."
L.DEFAULT_STEALTHED_CONDITION_TITLE = "Player Is Stealthed"
L.DEFAULT_STEALTHED_CONDITION_TOOLTIP = "Check this box to show an element if the player is stealthed."
L.DEFAULT_SWIMMING_CONDITION_TITLE = "Player Is Swimming"
L.DEFAULT_SWIMMING_CONDITION_TOOLTIP = "Check this box to show an element if the player is swimming."
L.DEFAULT_TARGET_AVAILABLE_CONDITION_TITLE = "Target Available"
L.DEFAULT_TARGET_AVAILABLE_CONDITION_TOOLTIP = "Check this box to show an element if the player has a target."
L.DEFAULT_TARGET_ENEMY_CONDITION_TITLE = "Target Is An Enemy"
L.DEFAULT_TARGET_ENEMY_CONDITION_TOOLTIP = "Check this box to show an element if the player's current target is considered an enemy."
L.DEFAULT_TARGET_HOSTILE_CONDITION_TITLE = "Target Is Neutral / Hostile"
L.DEFAULT_TARGET_HOSTILE_CONDITION_TOOLTIP = "Check this box to show an element if the player's current target is Neutral / Hostile."
L.DEFAULT_TARGET_IN_PARTY_CONDITION_TITLE = "Target Is In Party"
L.DEFAULT_TARGET_IN_PARTY_CONDITION_TOOLTIP = "Check this box to show an element if the player's current target is in the party."
L.DEFAULT_TARGET_IN_RAID_CONDITION_TITLE = "Target Is In Raid"
L.DEFAULT_TARGET_IN_RAID_CONDITION_TOOLTIP = "Check this box to show an element if the player's current target is in the raid."
L.DEFAULT_TARGET_PLAYER_CONDITION_TITLE = "Target Is Another Player"
L.DEFAULT_TARGET_PLAYER_CONDITION_TOOLTIP = "Check this box to show an element if the player's current target is another player."
L.DEFAULT_THIRSTY_CONDITION_TITLE = "Player Not Full Mana"
L.DEFAULT_THIRSTY_CONDITION_TOOLTIP = "Check this box to show an element if the player is not at full mana (Mana classes only)."

L.DEFAULT_OPTIONS_NAME = "Default UI"
L.DEFAULT_OPTIONS_TITLE = "Default Blizzard UI"
L.DEFAULT_OPTIONS_SUBTEXT = "These options affect the behaviour of all supported default interface elements."
L.DEFAULT_OPTIONS_ENABLED_TEXT = "Enabled"
L.DEFAULT_OPTIONS_ENABLED_TOOLTIP = "Enable or disable the Default UI module."
L.DEFAULT_OPTIONS_ELEMENT_ENABLED_TOOLTIP = "Check this box to enable the automated visibility of %s."
L.DEFAULT_OPTIONS_HOTSPOT_TEXT = "Enable Hotspot"
L.DEFAULT_OPTIONS_HOTSPOT_TOOLTIP = "Check this box to enable the ability to activate and display the element by mousing over its region."
L.DEFAULT_OPTIONS_MODE_TITLE = "Mode:"
L.DEFAULT_OPTIONS_MODE_TOOLTIP = ""

-- Chat Module
L.CHAT_MODE_GEMS_TITLE = "Chat Gems"
L.CHAT_MODE_GEMS_CONTROLLER_TOOLTIP = "Click to open chat."
L.CHAT_MODE_GEMS_CHANNEL_TOOLTIP_READ = "No unread message(s)."
L.CHAT_MODE_GEMS_CHANNEL_TOOLTIP_UNREAD = "%d unread message(s)."

L.CHAT_MSG_SAY = "Say"
L.CHAT_MSG_YELL = "Yell"
L.CHAT_MSG_BN_WHISPER = "Battle.Net Whisper"
L.CHAT_MSG_WHISPER = "Whisper"
L.CHAT_MSG_GUILD = "Guild"
L.CHAT_MSG_OFFICER = "Officer"
L.CHAT_MSG_PARTY = "Party"
L.CHAT_MSG_PARTY_LEADER = "Party Leader"
L.CHAT_MSG_RAID = "Raid"
L.CHAT_MSG_RAID_LEADER = "Raid Leader"
L.CHAT_MSG_RAID_WARNING = "Raid Warning"
L.CHAT_MSG_INSTANCE_CHAT = "Instance Chat"
L.CHAT_MSG_INSTANCE_CHAT_LEADER = "Instance Chat Leader"

L.CHAT_OPTIONS_NAME = "Chat"
L.CHAT_OPTIONS_TITLE = "Chat Windows"
L.CHAT_OPTIONS_SUBTEXT = "These options affect the behaviour of all chat windows."
L.CHAT_OPTIONS_ENABLED_TEXT = "Enabled"
L.CHAT_OPTIONS_ENABLED_TOOLTIP = "Enable or disable the Chat module."
L.CHAT_OPTIONS_HOTSPOT_TEXT = "Enable Hotspot"
L.CHAT_OPTIONS_HOTSPOT_TOOLTIP = "Check this box to enable the ability to activate and display a chat window by mousing over its region."
L.CHAT_OPTIONS_MODE_TITLE = "Mode:"
L.CHAT_OPTIONS_MODE_TOOLTIP = ""
L.CHAT_OPTIONS_ANCHOR_TITLE = "Anchor:"
L.CHAT_OPTIONS_ANCHOR_TOOLTIP = ""
L.CHAT_OPTIONS_ANCHOR_TOPLEFT = "Top Left"
L.CHAT_OPTIONS_ANCHOR_TOPRIGHT = "Top Right"
L.CHAT_OPTIONS_ANCHOR_BOTTOMLEFT = "Bottom Left"
L.CHAT_OPTIONS_ANCHOR_BOTTOMRIGHT = "Bottom Right"
L.CHAT_OPTIONS_DIRECTION_TITLE = "Direction:"
L.CHAT_OPTIONS_DIRECTION_TOOLTIP = ""
L.CHAT_OPTIONS_DIRECTION_HORIZONTAL = "Horizontal"
L.CHAT_OPTIONS_DIRECTION_VERTICAL = "Vertical"
L.CHAT_OPTIONS_MOVING_TEXT = "Enable Moving"
L.CHAT_OPTIONS_MOVING_TOOLTIP = "Check this box to enable the ability to hide the chat gems while moving."

-- ElvUI Module
L.ELVUI_OPTIONS_NAME = "ElvUI"
L.ELVUI_OPTIONS_TITLE = "ElvUI"
L.ELVUI_OPTIONS_SUBTEXT = "These options affect the behaviour of all supported ElvUI elements."
L.ELVUI_OPTIONS_ENABLED_TEXT = "Enabled"
L.ELVUI_OPTIONS_ENABLED_TOOLTIP = "Enable or disable the ElvUI module."

-- Tukui Module
L.TUKUI_OPTIONS_NAME = "Tukui"
L.TUKUI_OPTIONS_TITLE = "Tukui"
L.TUKUI_OPTIONS_SUBTEXT = "These options affect the behaviour of all supported Tukui elements."
L.TUKUI_OPTIONS_ENABLED_TEXT = "Enabled"
L.TUKUI_OPTIONS_ENABLED_TOOLTIP = "Enable or disable the Tukui module."
L.TUKUI_OPTIONS_NOTICE_TEXT = "|TInterface\\OptionsFrame\\UI-OptionsFrame-NewFeatureIcon:0:0:0:-1|t  Tukui support coming soon!"