﻿local Engine, Api, Locale, Settings = unpack(Immersive)

local Default = Engine:GetModule("Default")

-- Registers the element.
function Default:RegisterMicroButtonAndBagsBar()
	local settings = Settings:Get(self.Name).Elements["MicroButtonAndBagsBar"]
	local bar = Api:RegisterElement("MicroButtonAndBagsBar", settings)
	
	-- Add frames
	if not Engine.IsClassic then
		bar:AddFrame(CharacterMicroButton)
		bar:AddFrame(SpellbookMicroButton)
		bar:AddFrame(TalentMicroButton)
		bar:AddFrame(QuestLogMicroButton)
		bar:AddFrame(MainMenuMicroButton)
	end
	
	bar:AddFrame(MicroButtonAndBagsBar)
	bar:AddFrame(AchievementMicroButton)
	bar:AddFrame(GuildMicroButton)
	bar:AddFrame(LFDMicroButton)
	bar:AddFrame(EJMicroButton)
	bar:AddFrame(CollectionsMicroButton)
	bar:AddFrame(StoreMicroButton)
	
	-- Add conditions
	bar:AddConditionRange(settings.Conditions)
	
	-- Add hotspots
	if not Engine.IsClassic then
		bar:AddHotspot(MicroButtonAndBagsBar:GetRect())
	end
end

-- Unregisters the element.
function Default:UnregisterMicroButtonAndBagsBar()
	Api:UnregisterElement("MicroButtonAndBagsBar")
end

