XPRACTICE={}

XPRACTICE.Config={}
XPRACTICE.Config.Keybinds={}
XPRACTICE.Config.Camera={}

--------------------------------------------------------------------------------
--
--	User-editable values.
--  Changes will not take effect until you /reload World of Warcraft.
--
--------------------------------------------------------------------------------

-- Default "W".  Your movement speed is normally 7 yards per second.
XPRACTICE.Config.Keybinds.MoveForward="W"

-- Default "S".  Backtracking will cause you to move at reduced speed.
XPRACTICE.Config.Keybinds.MoveBackward="S"

-- Default "A".  Walk left while facing forward.  
XPRACTICE.Config.Keybinds.StrafeLeft="A"

-- Default "D".  Walk right while facing forward.
XPRACTICE.Config.Keybinds.StrafeRight="D"

-- Default "Q".
XPRACTICE.Config.Keybinds.TurnLeft="Q"

-- Default "E".
XPRACTICE.Config.Keybinds.TurnRight="E"

-- Default "SPACE".
XPRACTICE.Config.Keybinds.Jump="SPACE"

-- Default "NUMPADDIVIDE".
XPRACTICE.Config.Keybinds.ToggleRunWalk="NUMPADDIVIDE"


-- Default 9.0.  Affects how quickly the 3D camera rotates as you move the mouse.
-- Adjust this value to match World of Warcraft.  Camera speed is also affected by screen size;
-- the smaller your screen, the faster the camera rotates.
XPRACTICE.Config.Camera.CameraSpeed=9.0

-- Default 0.35.  Affects how quickly the cursor drifts as you move the 3D camera.
-- Since this value directly affects mouse speed, it also acts as a multiplier to camera speed;
-- be sure to adjust CameraSpeed above after changing this value.
XPRACTICE.Config.Camera.MouseSpeed=0.35

-- Mouse inversion settings have been removed.
-- The game will now attempt to auto-detect whether you have enabled mouse inversion 
-- in World of Warcraft's Interface menu and mimic your settings appropriately.




-------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------
--
-- CHANGE THE FOLLOWING LINES AT YOUR OWN RISK
--
-------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------

XPRACTICE.DEBUG={}

-- CHANGE THIS LINE TO FALSE BEFORE PUBLISHING
if(false)then
	XPRACTICE.DEBUG.debugprint=true
	XPRACTICE.DEBUG.extraslashcommands=true	
		
	XPRACTICE.DEBUG.quickloadscenario=true
		
	-- when true, several additional testing buttons will be visible.
	-- (may not work in the current version. use at your own risk.)
	XPRACTICE.DEBUG.visiblebosscontrolbuttons=true
	
	-- when true, /xp can open multiple games at once
	-- XPRACTICE.DEBUG.allowmultiboxing=false
	
	-- when true, /xp while the game is running will shutdown and restart instead of displaying an error message
	-- XPRACTICE.DEBUG.autoshutdownrestart=false
	
	-- change this key to whatever our /reload macro is set to (e.g. "R")
	-- change to nil (not "false") to disable
	XPRACTICE.DEBUG.extrapassthrukeycode="R"
	
	--XPRACTICE.DEBUG.visiblemobclickzones=true
	
	
end

function XPRACTICE.debugprint(str)
	if(XPRACTICE.DEBUG.debugprint)then
		print(str)
	end
end

function XPRACTICE.FrameVisibilityCheck(frame)
	if(not XPRACTICE)then local XPRACTICE=self.XPRACTICE end
	print("Checking frame",tostring(frame))
	print("Name:",tostring(frame.name))
	print("Parent:",tostring(frame:GetParent()))
	print("Width:",frame:GetWidth())
	print("Height:",frame:GetHeight())	
	print("Framelevel:",frame:GetFrameLevel())	
	print("Shown:",frame:IsShown())
	print("Alpha:",frame:GetAlpha())	-- GetAlpha() does not actually grant alpha access.  I've tried.
	
	--LoadAddOn("Blizzard_DebugTools")	--TODO: LoadAddOn probably needs time to execute
	--DevTools_Dump(frame:GetAllPoints())	
end

